Index: /trunk/SRC/ToBeReviewed/HOPE/read_hope.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/HOPE/read_hope.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/HOPE/read_hope.pro	(revision 114)
@@ -111,4 +111,7 @@
 ;
 pro read_hope_event, event
+;
+  compile_opt idl2, strictarrsubs
+;
    widget_control, event.id, get_uvalue=uval
    widget_control, event.top, get_uvalue=top_uvalue
@@ -297,4 +300,7 @@
 ;
 FUNCTION read_hope, typein, varnamein, FILENAME = filename, XLIMITS = xlimits, YLIMITS = ylimits,  ZLIMITS = zlimits, TLIMITS = tlimits, ODDPT = oddpt, ODDEVENPT = oddevenpt, EVENPT = evenpt, _extra = ex
+;
+  compile_opt idl2, strictarrsubs
+;
 @common                         ; usefull only for the definition of iodir 
   if n_elements(filename) EQ 0 then filename = isafile(iodirectory = iodir, _extra = ex)
Index: /trunk/SRC/ToBeReviewed/HOPE/rh_alldomains.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/HOPE/rh_alldomains.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/HOPE/rh_alldomains.pro	(revision 114)
@@ -1,3 +1,6 @@
 PRO rh_alldomains, topid, selected
+;
+  compile_opt idl2, strictarrsubs
+;
 
    widget_control, topid, get_uvalue=top_uvalue
Index: /trunk/SRC/ToBeReviewed/HOPE/sortdim.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/HOPE/sortdim.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/HOPE/sortdim.pro	(revision 114)
@@ -17,4 +17,7 @@
 ;
 ;
+;
+  compile_opt idl2, strictarrsubs
+;
    tosort = dims
    if n_elements(tosort) eq 1 then $
Index: /trunk/SRC/ToBeReviewed/HOPE/xrh.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/HOPE/xrh.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/HOPE/xrh.pro	(revision 114)
@@ -1,4 +1,7 @@
 ; procedure to call read_hope in the widget mode
 PRO xrh, _extra = ex
+;
+  compile_opt idl2, strictarrsubs
+;
    a = read_hope(_extra = ex)
    return
Index: /trunk/SRC/ToBeReviewed/IMAGE/animgif.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/IMAGE/animgif.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/IMAGE/animgif.pro	(revision 114)
@@ -42,4 +42,7 @@
 ;------------------------------------------------------------
 PRO animgif, nomfic
+;
+  compile_opt idl2, strictarrsubs
+;
 @common
 ;
Index: /trunk/SRC/ToBeReviewed/IMAGE/image_viewer.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/IMAGE/image_viewer.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/IMAGE/image_viewer.pro	(revision 114)
@@ -48,4 +48,7 @@
 ;THIS PROCEDURE IS CALLED WHEN A USER SELECTS "File > Open Picture Files" FROM THE MAIN MENU
 ;error handling:
+;
+  compile_opt idl2, strictarrsubs
+;
 !ERROR_STATE.CODE=0
 CATCH,error
@@ -126,4 +129,7 @@
 ;THIS PROCEDURE IS CALLED WHEN A USER SELECTS "File > Open All In Folder" FROM THE MAIN MENU
 ;error handling:
+;
+  compile_opt idl2, strictarrsubs
+;
 !ERROR_STATE.CODE=0
 CATCH,error
@@ -204,4 +210,7 @@
 PRO IMAGE_VIEWER_CANCEL,event
 ;obtain state structure for top-level-base from its UVALUE:
+;
+  compile_opt idl2, strictarrsubs
+;
 WIDGET_CONTROL,event.top,GET_UVALUE=pState
 ;shut-off timer:
@@ -214,4 +223,7 @@
 PRO IMAGE_VIEWER_TIMER,event
 ;obtain state structure for top-level-base from its UVALUE:
+;
+  compile_opt idl2, strictarrsubs
+;
 WIDGET_CONTROL,event.top,GET_UVALUE=pState
 if (*pState).timer EQ 1 then begin ;continue processing files:
@@ -884,4 +896,7 @@
 ;THIS PROCEDURE IS CALLED WHEN A USER SELECTS "File > Exit" FROM THE MAIN MENU
 ;terminate the program by destroying the top-level-base (widgetID always stored in event.top):
+;
+  compile_opt idl2, strictarrsubs
+;
 WIDGET_CONTROL,event.top,/DESTROY
 END
@@ -894,4 +909,7 @@
 ;FROM THE MAIN MENU
 ;display a simple message:
+;
+  compile_opt idl2, strictarrsubs
+;
 messageStr=['IMAGE_VIEWER written by AEB, 2002.','',$
             'The purpose of this program is to provide an interactive tool that can be used',$
@@ -909,4 +927,7 @@
 ;THIS PROCEDURE IS CALLED WHEN A USER CLICKS ON ONE OF THE THUMBNAIL PICTURES
 ;error handling:
+;
+  compile_opt idl2, strictarrsubs
+;
 !ERROR_STATE.CODE=0
 CATCH,error
@@ -953,4 +974,7 @@
 ;THIS PROCEDURE IS CALLED WHEN THE PROGRAM IS TERMINATED AND XMANAGER REGISTERS A CLEANUP:
 ;obtain state structure for top-level-base from its uvalue:
+;
+  compile_opt idl2, strictarrsubs
+;
 WIDGET_CONTROL,widgetID,GET_UVALUE=pState
 ;test for validity of state structure pointer:
@@ -978,4 +1002,7 @@
 ;THIS PROCEDURE IS CALLED WHEN A USER RESIZES THE TOP-LEVEL BASE
 ;error handling:
+;
+  compile_opt idl2, strictarrsubs
+;
 !ERROR_STATE.CODE=0
 CATCH,error
@@ -997,4 +1024,7 @@
 PRO IMAGE_VIEWER
 ;error handling:
+;
+  compile_opt idl2, strictarrsubs
+;
 !ERROR_STATE.CODE=0
 CATCH,error
Index: /trunk/SRC/ToBeReviewed/IMAGE/imdisp.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/IMAGE/imdisp.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/IMAGE/imdisp.pro	(revision 114)
@@ -1,4 +1,7 @@
 ;-------------------------------------------------------------------------------
 FUNCTION IMDISP_GETPOS, ASPECT, POSITION=POSITION, MARGIN=MARGIN
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;- Compute a position vector given an aspect ratio (called by IMDISP_IMSIZE)
@@ -46,4 +49,7 @@
 FUNCTION IMDISP_IMSCALE, IMAGE, RANGE=RANGE, BOTTOM=BOTTOM, NCOLORS=NCOLORS, $
   NEGATIVE=NEGATIVE
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;- Byte-scale an image (called by IMDISP)
@@ -73,4 +79,7 @@
 ;-------------------------------------------------------------------------------
 FUNCTION IMDISP_IMREGRID, DATA, NX, NY, INTERP=INTERP
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;- Regrid a 2D array (called by IMDISP)
@@ -112,4 +121,7 @@
 PRO IMDISP_IMSIZE, IMAGE, X0, Y0, XSIZE, YSIZE, ASPECT=ASPECT, $
   POSITION=POSITION, MARGIN=MARGIN
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;- Compute the size and offset for an image (called by IMDISP)
@@ -171,4 +183,7 @@
   BACKGROUND=BACKGROUND, ERASE=ERASE, $
   AXIS=AXIS, NEGATIVE=NEGATIVE, _EXTRA=EXTRA_KEYWORDS
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;+
Index: /trunk/SRC/ToBeReviewed/IMAGE/saveimage.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/IMAGE/saveimage.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/IMAGE/saveimage.pro	(revision 114)
@@ -1,4 +1,7 @@
 PRO SAVEIMAGE, FILE, BMP=BMP, PNG=PNG, PICT=PICT, JPEG=JPEG, TIFF=TIFF, $
   QUALITY=QUALITY, DITHER=DITHER, CUBE=CUBE, QUIET=QUIET, MULTIPLE = multiple
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;+
Index: /trunk/SRC/ToBeReviewed/IMAGE/showimage.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/IMAGE/showimage.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/IMAGE/showimage.pro	(revision 114)
@@ -1,3 +1,6 @@
 PRO SHOWIMAGE, FILE, DITHER=DITHER, CURRENT=CURRENT
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;+
Index: /trunk/SRC/ToBeReviewed/INIT/initncdf.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/INIT/initncdf.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/INIT/initncdf.pro	(revision 114)
@@ -91,4 +91,7 @@
               , XYINDEX = xyindex, ZINDEX = zindex $
               , _EXTRA = ex
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
 @common
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/bit2int.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/bit2int.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/bit2int.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION bit2int, bitin, checkneg = checkneg
+;
+  compile_opt idl2, strictarrsubs
+;
 
   res = 0L
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib.pro	(revision 114)
@@ -1,3 +1,6 @@
 function read_grib, varcode, date1, date2, file = file
+;
+  compile_opt idl2, strictarrsubs
+;
 @common
 ; http://www.wmo.ch/web/www/WDM/Guides/Guide-binary-2.html
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_bds.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_bds.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_bds.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION read_grib_bds, num, recstart, ni, nj
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
   offset = recstart+8
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_end.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_end.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_end.pro	(revision 114)
@@ -1,3 +1,6 @@
 PRO read_grib_end,  num, offset
+;
+  compile_opt idl2, strictarrsubs
+;
 
   a = assoc(num, bytarr(4, /nozero), offset)
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_gds.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_gds.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_gds.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION read_grib_gds, num, recstart
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
   offset = recstart+8
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_is.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_is.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_is.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION read_grib_is, num, offset
+;
+  compile_opt idl2, strictarrsubs
+;
 
   infofile = fstat(num)
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_pds.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_pds.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_grib_pds.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION read_grib_pds, num, recstart
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
   offset = recstart+8
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_gribtable.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_gribtable.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/read_gribtable.pro	(revision 114)
@@ -40,4 +40,7 @@
 PRO read_gribtable,tablename,parmtabl=parmtabl,center=center,$
                    subcenter=subcenter,tablnum=tablnum
+;
+  compile_opt idl2, strictarrsubs
+;
   
 ON_ERROR,2
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_code.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_code.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_code.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION scan_grib_code, num, recstart
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
   nrec =  n_elements(recstart)
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_date.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_date.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_date.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION scan_grib_date, num, recstart
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
   nrec =  n_elements(recstart)
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_messize.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_messize.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_messize.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION scan_grib_messize, num, recstart
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
   nrec =  n_elements(recstart)
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_nbits.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_nbits.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_nbits.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION scan_grib_nbits, num, recstart
+;
+  compile_opt idl2, strictarrsubs
+;
 
 ;
Index: /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_recstart.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_recstart.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/GRIB/scan_grib_recstart.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION scan_grib_recstart, num
+;
+  compile_opt idl2, strictarrsubs
+;
 
   infofile = fstat(num)
Index: /trunk/SRC/ToBeReviewed/LECTURE/binary.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/binary.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/binary.pro	(revision 114)
@@ -38,4 +38,7 @@
 ;-
 function binary, number
+;
+  compile_opt idl2, strictarrsubs
+;
   s = size(number)
   type = s[s[0] + 1]
Index: /trunk/SRC/ToBeReviewed/LECTURE/changeread.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/changeread.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/changeread.pro	(revision 114)
@@ -1,3 +1,6 @@
 FUNCTION changeread, newread
+;
+;
+  compile_opt idl2, strictarrsubs
 ;
 @common
Index: /trunk/SRC/ToBeReviewed/LECTURE/inverse_binary.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/inverse_binary.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/inverse_binary.pro	(revision 114)
@@ -62,4 +62,7 @@
 FUNCTION inverse_binary, binnumb
 ;
+;
+  compile_opt idl2, strictarrsubs
+;
   s = size(binnumb, /dimensions)
   IF n_elements(s) EQ 1 THEN numbofbit = 8 ELSE numbofbit = 8*s[1]
Index: /trunk/SRC/ToBeReviewed/LECTURE/litchamp.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/litchamp.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/litchamp.pro	(revision 114)
@@ -105,4 +105,7 @@
 FUNCTION litchamp, struct, GRID = grid, NAME = name, UNIT = unit, EXP = exp, DATE = date $
                    , LEVEL = level, MASK = mask
+;
+  compile_opt idl2, strictarrsubs
+;
 @common
 ;------------------------------------------------------------
Index: /trunk/SRC/ToBeReviewed/LECTURE/ncdf_lec.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/ncdf_lec.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/ncdf_lec.pro	(revision 114)
@@ -42,4 +42,7 @@
 ;------------------------------------------------------------
 function ncdf_lec,nom,ATT=att,DIM=dim,VAR=var, IODIR = iodir, _extra = ex
+;
+  compile_opt idl2, strictarrsubs
+;
    res = -1
 ;------------------------------------------------------------
@@ -124,5 +127,5 @@
           then begin
             print,'variable numero: ',strtrim(varid,1),', nom:',varcontent.name $
-             ,', type:' ,varcontent.datatype,', dimensions:',nomdim(varcontent.dim)
+             ,', type:' ,varcontent.datatype,', dimensions:',nomdim[varcontent.dim]
             if strlowcase(att) eq strlowcase(varcontent.name) then begin
                for attiq=0,varcontent.natts-1 do begin
Index: /trunk/SRC/ToBeReviewed/LECTURE/read_ncdf.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/read_ncdf.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/read_ncdf.pro	(revision 114)
@@ -78,4 +78,7 @@
                     , GRID = grid, FBASE2TBASE = fbase2tbase, _EXTRA = ex
 ;---------------------------------------------------------
+;
+  compile_opt idl2, strictarrsubs
+;
 @cm_4mesh
 @cm_4data
Index: /trunk/SRC/ToBeReviewed/LECTURE/xncdf_lec.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/LECTURE/xncdf_lec.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/LECTURE/xncdf_lec.pro	(revision 114)
@@ -18,4 +18,7 @@
 ;------------------------------------------------------------
 ;------------------------------------------------------------
+;
+  compile_opt idl2, strictarrsubs
+;
    COMMON wididbase, base
    COMMON resultat, res
@@ -200,4 +203,7 @@
 ;------------------------------------------------------------
 ;------------------------------------------------------------
+;
+  compile_opt idl2, strictarrsubs
+;
    COMMON resultat, res
    COMMON infovariable, cdfid, listename, contient, nomdim, tailledim, varid, varcontient
@@ -306,4 +312,7 @@
 ;------------------------------------------------------------
 ;------------------------------------------------------------
+;
+  compile_opt idl2, strictarrsubs
+;
    COMMON resultat, res
    COMMON infovariable, cdfid, listename, contient, nomdim, tailledim, varid, varcontient
@@ -408,4 +417,7 @@
 ;------------------------------------------------------------
 FUNCTION xncdf_lec, nom, ATT = att, COUNT = count, GROUP = group, OFFSET = offset, IODIR = iodir, SHIFT = shift,  STRIDE = stride, VAR = var
+;
+  compile_opt idl2, strictarrsubs
+;
    COMMON wididbase, base
    COMMON infovariable, cdfid, listename, contient, nomdim, tailledim, varid, varcontient
Index: /trunk/SRC/ToBeReviewed/MATRICE/cmapply.pro
===================================================================
--- /trunk/SRC/ToBeReviewed/MATRICE/cmapply.pro	(revision 113)
+++ /trunk/SRC/ToBeReviewed/MATRICE/cmapply.pro	(revision 114)
@@ -149,5 +149,5 @@
 ;   OUT             FLOAT     = Array[10, 10]
 ;
-;   (OUT(i,j) is the median value of IN(i,j,*))
+;   (OUT[i,j] is the median value of IN[i,j,*])
 ;
 ; MODIFICATION HISTORY:
@@ -175,30 +175,36 @@
 ;; Utility function, adapted from CMPRODUCT
 function cmapply_product, x
+;
+  compile_opt idl2, strictarrsubs
+;
   sz = size(x)
-  n = sz(1)
+  n = sz[1]
 
   while n GT 1 do begin
-      if (n mod 2) EQ 1 then x(0,*) = x(0,*) * x(n-1,*)
+      if (n mod 2) EQ 1 then x[0,*] = x[0,*] * x[n-1,*]
       n2 = floor(n/2)
-      x = x(0:n2-1,*) * x(n2:*,*)
+      x = x[0:n2-1,*] * x[n2:*,*]
       n = n2
   endwhile
-  return, reform(x(0,*), /overwrite)
+  return, reform(x[0,*], /overwrite)
 end
 
 ;; Utility function, used to collect collaped dimensions
 pro cmapply_redim, newarr, dimapply, dimkeep, nkeep, totcol, totkeep
+;
+  compile_opt idl2, strictarrsubs
+;
   sz = size(newarr)
   ;; First task: rearrange dimensions so that the dimensions
   ;; that are "kept" (ie, uncollapsed) are at the back
-  dimkeep = where(histogram(dimapply,min=1,max=sz(0)) ne 1, nkeep)
+  dimkeep = where(histogram(dimapply,min=1,max=sz[0]) ne 1, nkeep)
   if nkeep EQ 0 then return
 
   newarr = transpose(temporary(newarr), [dimapply-1, dimkeep])
   ;; totcol is the total number of collapsed elements
-  totcol = sz(dimapply(0))
-  for i = 1, n_elements(dimapply)-1 do totcol = totcol * sz(dimapply(i))
-  totkeep = sz(dimkeep(0)+1)
-  for i = 1, n_elements(dimkeep)-1 do totkeep = totkeep * sz(dimkeep(i)+1)
+  totcol = sz[dimapply[0]]
+  for i = 1, n_elements(dimapply)-1 do totcol = totcol * sz[dimapply[i]]
+  totkeep = sz[dimkeep[0]+1]
+  for i = 1, n_elements(dimkeep)-1 do totkeep = totkeep * sz[dimkeep[i]+1]
 
   ;; this new array has two dimensions:
@@ -213,4 +219,7 @@
 function cmapply, op, array, dimapply, double=dbl, type=type, $
                   functargs=functargs, nocatch=nocatch
+;
+  compile_opt idl2, strictarrsubs
+;
 
   if n_params() LT 2 then begin
@@ -227,15 +236,15 @@
   ;; 1) the dimensions of the array
   sz = size(array)
-  if sz(0) EQ 0 then $
+  if sz[0] EQ 0 then $
     message, 'ERROR: ARRAY must be an array!'
 
   ;; 2) The type of the array
-  if sz(sz(0)+1) EQ 0 OR sz(sz(0)+1) EQ 7 OR sz(sz(0)+1) EQ 8 then $
+  if sz[sz[0]+1] EQ 0 OR sz[sz[0]+1] EQ 7 OR sz[sz[0]+1] EQ 8 then $
     message, 'ERROR: Cannot apply to UNDEFINED, STRING, or STRUCTURE'
-  if n_elements(type) EQ 0 then type = sz(sz(0)+1)
+  if n_elements(type) EQ 0 then type = sz[sz[0]+1]
 
   ;; 3) The type of the operation
   szop = size(op)
-  if szop(szop(0)+1) NE 7 then $
+  if szop[szop[0]+1] NE 7 then $
     message, 'ERROR: operation OP was not a string'
 
@@ -243,5 +252,5 @@
   if n_params() EQ 2 then dimapply = 1
   dimapply = [ dimapply ]
-  dimapply = dimapply(sort(dimapply))   ; Sort in ascending order
+  dimapply = dimapply[sort(dimapply)]   ; Sort in ascending order
   napply = n_elements(dimapply)
 
@@ -254,5 +263,5 @@
   newop = strupcase(op)
   newarr = array
-  newarr = reform(newarr, sz(1:sz(0)), /overwrite)
+  newarr = reform(newarr, sz[1:sz[0]], /overwrite)
   case 1 of
 
@@ -260,5 +269,5 @@
       (newop EQ '+'): begin
           for i = 0L, napply-1 do begin
-              newarr = total(temporary(newarr), dimapply(i)-i, double=dbl)
+              newarr = total(temporary(newarr), dimapply[i]-i, double=dbl)
           endfor
       end
@@ -269,9 +278,9 @@
           if nkeep EQ 0 then begin
               newarr = reform(newarr, n_elements(newarr), 1, /overwrite)
-              return, (cmapply_product(newarr))(0)
+              return, (cmapply_product(newarr))[0]
           endif
 
           result = cmapply_product(newarr)
-          result = reform(result, sz(dimkeep+1), /overwrite)
+          result = reform(result, sz[dimkeep+1], /overwrite)
           return, result
       end
@@ -282,6 +291,6 @@
           totelt = 1L
           for i = 0L, napply-1 do begin
-              newarr = total(temporary(newarr), dimapply(i)-i)
-              totelt = totelt * sz(dimapply(i))
+              newarr = total(temporary(newarr), dimapply[i]-i)
+              totelt = totelt * sz[dimapply[i]]
           endfor
           if newop EQ 'AND' then return, (round(newarr) EQ totelt)
@@ -305,20 +314,20 @@
           if totcol LT totkeep then begin
               ;; Iterate over the number of collapsed elements
-              result(0) = reform(newarr(0,*),totkeep,/overwrite)
+              result[0] = reform(newarr[0,*],totkeep,/overwrite)
               case newop of 
                   'MAX': for i = 1L, totcol-1 do $
-                    result(0) = result > newarr(i,*)
+                    result[0] = result > newarr[i,*]
                   'MIN': for i = 1L, totcol-1 do $
-                    result(0) = result < newarr(i,*)
+                    result[0] = result < newarr[i,*]
               endcase
           endif else begin
               ;; Iterate over the number of output elements
               case newop of 
-                  'MAX': for i = 0L, totkeep-1 do result(i) = max(newarr(*,i))
-                  'MIN': for i = 0L, totkeep-1 do result(i) = min(newarr(*,i))
+                  'MAX': for i = 0L, totkeep-1 do result[i] = max(newarr[*,i])
+                  'MIN': for i = 0L, totkeep-1 do result[i] = min(newarr[*,i])
               endcase
           endelse
 
-          result = reform(result, sz(dimkeep+1), /overwrite)
+          result = reform(result, sz[dimkeep+1], /overwrite)
           return, result
       end
@@ -343,11 +352,11 @@
           if n_elements(functargs) GT 0 then begin
               for i = 0L, totkeep-1 do $
-                result(i) = call_function(functname, newarr(*,i), _EXTRA=functargs)
+                result[i] = call_function(functname, newarr[*,i], _EXTRA=functargs)
           endif else begin
               for i = 0L, totkeep-1 do $
-                result(i) = call_function(functname, newarr(*,i))
+                result[i] = call_function(functname, newarr[*,i])
           endelse
 
-          result = reform(result, sz(dimkeep+1), /overwrite)
+          result = reform(result, sz[dimkeep+1], /overwrite)
           return, result
       end
@@ -357,5 +366,5 @@
 
   newsz = size(newarr)
-  if type EQ newsz(newsz(0)+1) then return, newarr
+  if type EQ newsz[newsz[0]+1] then return, newarr
 
   ;; Cast the result into the desired type, if necessary
@@ -363,7 +372,7 @@
              'DOUBLE', 'COMPLEX', 'UNDEF', 'UNDEF', 'DCOMPLEX' ]
   if type GE 1 AND type LE 3 then $
-    return, call_function(castfns(type), round(newarr)) $
+    return, call_function(castfns[type], round(newarr)) $
   else $
-    return, call_function(castfns(type), newarr)
+    return, call_function(castfns[type], newarr)
 end
   
